﻿using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace Mod
{
    class EMP4 : MonoBehaviour
    {
        public string Particle = "Disintegration";

        void Use()
        {
            RaycastHit2D hit = Physics2D.Raycast(transform.position, transform.up, 0.01f, LayerMask.GetMask("Objects"));
            if (hit.collider == null) return;
            ModAPI.CreateParticleEffect(Particle, hit.point);

            var allPhysicalChildren = hit.transform.root.GetComponentsInChildren<PhysicalBehaviour>();
            if (allPhysicalChildren.Length == 0) return;
            var consideredWeightless = allPhysicalChildren[0].IsWeightless;

            foreach (var phys in allPhysicalChildren)
            {
                if (consideredWeightless)
                {
                    phys.MakeWeightful();
                }
                else
                {
                    phys.MakeWeightless();
                }
            }
        }
    }
}